#if !defined(_BifsEnc_h)	// Sentry, use file only if it's not already included.
#define _BifsEnc_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Encoder
FILE:       BifsEnc.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Implementation of BIFSEncoder, the class that encodes date into
			bits.
-------------------------------------------------------------------------*/

class MediaObject;

class BIFSEncoder
{
	FILE *m_fList, *m_fBifs;
	int m_bLastByte, m_nBitCount, m_nAULength;
	BYTE m_buffer [255];
	DWORD m_dwTS;

public:
	void Encode ();
	BIFSEncoder (FILE *fBifs, FILE *fList);
	void Flush ();
	void EncodeInt (int nValue, int nBits, LPCSTR szDesc);
	void EncodeFloat (float fValue);
	void EncodeDouble (double dValue);

private:
	void EncodeScene ();
	void ReplaceRoute ();
	void SceneReplaceCommand ();
	void EncodeRouteDetails ();
	int EncodeNodeID ();
	void EncodeRouteID ();
	void AppendCommand ();
	MediaObject *ScanNode ();
	void InsertToField (BOOL bAppend);
	void DeleteCommand ();
	void ReplaceCommand ();
	void InsertCommand ();
	void StoreTimeStamp (DWORD dwTS);
	void UpdateScene ();
	void EncodeRoute ();
	void EncodeRoutesDescription ();
	void WriteBit (BOOL bit);
};

#endif                                      // _BifsEnc_h sentry.
