/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor
FILE:       EncQuant.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Implementation of Quantizer functions for BIFS encoding
-------------------------------------------------------------------------*/

#include "defs.h"
#include "Quantize.h"
#include "BifsEnc.h"
#include <float.h>
#include "ztl.h"

void Quantizer :: EncodeInt (BIFSEncoder *pBifs, int nValue)
{
	/*-----------------------------------------------------------------
	Determine offset and number of bits
	-----------------------------------------------------------------*/
	int nOffset = 0, nBits = 32;
	if (m_nDimension == 1 &&
		m_pMin [0] != FLT_MIN && m_pMax [0] != FLT_MAX
	)
	{	int min = m_pMin [0];
		int max = m_pMax [0];
		nBits = BitFieldWidth (max - min + 1);
		nOffset = min;
	}
	pBifs -> EncodeInt (nValue - nOffset, nBits, "value");
}
