/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFSEncoder
FILE:       main.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   main() function for the BIFS encoder.
-------------------------------------------------------------------------*/
#include "defs.h"
#include "BifsEnc.h"

#define MAIN
#include "Token.h"

Token nextToken;

int main (int argc, char **argv)
{
	FILE *fInput, *fBifs, *fList;
	int nNameLength;

	if (argc < 2)
	{	printf ("Missing file name\n");
		return -1;
	}

	/*-----------------------------------------------------------------
	Source file name extension is "txt", output extension is "bif" and
	list file is "lst"
	-----------------------------------------------------------------*/
	ZString stFileName (*++argv);
	nNameLength = stFileName.GetLength ();
	LPCSTR szExt = strrchr (stFileName, '.');
	if (szExt && !strchr (szExt, '\\'))
		nNameLength -= strlen (szExt);
	else
		stFileName += ".txt";

	if ((fInput = fopen (stFileName, "r")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}
	stFileName.Cut (nNameLength);
	stFileName += ".bif";
	if ((fBifs = fopen (stFileName, "wb")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}
	stFileName.Cut (nNameLength);
	stFileName += ".lst";
	if ((fList = fopen (stFileName, "w")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}

	nextToken.Init (fInput, fList);
	BIFSEncoder encoder (fBifs, fList);
	encoder.Encode ();
	encoder.Flush ();
	return 0;
}

