#ifndef INCLUDED_AACDECODER_H
#define INCLUDED_AACDECODER_H

#include "Decoder.h"

class Executive;

class AACDecoder : public Decoder
{
	public:
		AACDecoder( Executive *pExecutive );
		virtual ~AACDecoder();

		/* overrides from class Decoder */
		virtual FORMAT SetFormat(Capabilities *pPresentationCapabilities );
		virtual int GetOptimalInputSize();
		virtual int GetOptimalOutputSize();
		virtual int GetRecommendedInputBufferSize();
		virtual int GetRecommendedOutputBufferSize();
		virtual BOOL Decode( LPBYTE pInput,int nInputLength, LPBYTE pOutput,int &rnOutputLength );
	private:
		int getAU();
		void* m_pluginHandle;
		void* m_pluginInstanceData;
		long (*m_decodeFrame)( void* instanceData, void* AUBuf, int AUBuflen, void* outbuf, long outBytes );
		int  (*m_initInstance)( void** instanceData );
		int  (*m_releaseInstance)( void* instanceData );
		long  m_targetBitrate;
		long  m_targetSampleRate;
		long  m_PUlen;
		double  m_timeStampIncrement; // microseconds
		double  m_timeStamp;          // microseconds
		char              *m_AUBuf;
		int                m_AUBuflen;	
		BOOL m_firstDecode;
};


#endif
