///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File:  CircleProxy.h
//
// Author: Antonio Arena, CSELT, arena@kim.cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the Circle node.
//
// Created: September, 1997.
//
// Modified:
//
///////////////////////////////////////////////////////////////////////////


#ifndef CIRCLE_PROXY_H
#define CIRCLE_PROXY_H


#include "GeometryNode.h"


class CircleProxy : public GeometryNode
{
public:
	PointF m_lpPoints[2];
	PointF m_shadows[2];

public:
	CircleProxy(MediaObject* pMO) : GeometryNode(pMO) {}

	// Return a pointer to the Circle node that this node is the proxy for
	Circle* GetCircle() const { return (Circle*)GetObject(); }

	// Functions inherited from the base class
	void PreRender(Effects const& effects);
	void Print(FILE* outfile, int depth) const;
	void Draw(BRect const* pClipBRect);
};

#endif // CIRCLE_PROXY_H
