///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File: DaiSession.h
//
// Authors: Nuno Delgado, CSELT
//
// Description:
//
///////////////////////////////////////////////////////////////////////////


#ifndef _DaiSession_h
#define _DaiSession_h


// Prevent inclusion of winsock.h in windows.h
#ifndef _WINSOCKAPI_
#define _WINSOCKAPI_
#endif
#include "winsock2.h"
#include "DmifPeer.h"
#include "ztl.h"

class Dai;
class CDmifPeer;

class ListOfPeersElement
{
	public:
		ListOfPeersElement* pNextElement;
		CDmifPeer*	pDmifPeer;

		ListOfPeersElement(){pNextElement = NULL;}
		~ListOfPeersElement() {}
};





class DaiSession
{
		
	private:
		Dai* m_pDai;

		CRITICAL_SECTION mPeersListCriticalSection;
		CRITICAL_SECTION mAddAndRemoveDataChannelsCriticalSection;
		int GetNewTransMuxTagNumber(unsigned int);
		int GetNewChannelAssociationTagNumber();
		void RemoveAndDestroyAllPeersInList();
		void SignalAllPeersOfSessionDestroy();


	public:
		unsigned int m_SessionID;     // The ID number of this session
		ListOfPeersElement* pHeadListOfPeersElement;
		WSAEVENT m_hEndThreadEvent;
		WSAEVENT m_hRefreshTableEvent;
		ZArray<WSAEVENT> m_WsaEventArray;
		BOOL m_ThreadCreated;
		
		DaiSession(Dai*);
		~DaiSession();
		void FillTableOfTags(int(*)[6], int);
		void AddPeerToList(CDmifPeer*);
		BOOL FindPeerInList(char*, CDmifPeer**);
		BOOL RemoveAndDestroyPeerFromList(char*);
		void EnterDataChannelsCriticalSection();
		void LeaveDataChannelsCriticalSection();
		void FillEventArray(WSAEVENT);

};
#endif