///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File:  G723Dec.h
//
//
// Description: G723 Decoder class declaration
//   .
// Created: September, 1997.
//
// Modified: Patrizio Bergallo, CSELT, patrizio.bergallo@cselt.it
//
///////////////////////////////////////////////////////////////////////////


#ifndef G723DEC_H
#define G723DEC_H


#include "Decoder.h"


class G723Decoder : public Decoder
{
	DWORD m_dwTime;
	BOOL m_firstDecode;

	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () {return 24;}
	virtual int GetOptimalOutputSize ()
	{ return 480 + sizeof(DecoderAudioFormat); }
	virtual int GetRecommendedInputBufferSize () {return 256;}
	virtual int GetRecommendedOutputBufferSize () {return 9600;}
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	virtual void Run ();


public:
	G723Decoder (class Executive *pExecutive);
	virtual ~G723Decoder();
};


#endif // G723DEC_H
