// MainFrm.cpp : implementation of the CMainFrame class
//

#include "defs.h"
#include "MPEG4Player.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_TOOLBAR, OnViewToolbar)
	ON_COMMAND(ID_VIEW_STATUS_BAR, OnViewStatusBar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

#ifdef USE_TOOLBAR
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
#endif

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

#ifdef USE_TOOLBAR
	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
#endif

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    // Create a child window without the maximize button 
    cs.style &= ~WS_MAXIMIZEBOX; 
    cs.style &= ~WS_THICKFRAME; 

	// Determine how large to make the window to fit in the required
	// client area
	RECT rect;
	rect.left = ::GetSystemMetrics(SM_CXSCREEN) / 4;
	rect.right = 352;
	rect.top = ::GetSystemMetrics(SM_CYSCREEN) / 4;
	rect.bottom = 288;
	AdjustWindowRectEx(&rect, cs.style, TRUE, cs.dwExStyle);

	// Still need to allow for the height of the toolbar and status bar

	// Set the size and placement of the window
    cs.cy = rect.bottom; 
    cs.cx = rect.right; 
    cs.y = rect.top; 
    cs.x = rect.left;

	return CFrameWnd::PreCreateWindow(cs);
} /* CMainFrame::PreCreateWindow */


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////

//
// Set the size of the client area to the given size.
//

void CMainFrame::SetSize(UINT width, UINT height)
{
	// Determine how large to make the window to fit in the required
	// client area
	RECT winRect;
	winRect.left = 0;
	winRect.right = width;
	winRect.top = 0;
	winRect.bottom = height;
	AdjustWindowRectEx(&winRect, GetStyle(), TRUE, GetExStyle());
	winRect.bottom -= winRect.top;
	winRect.right -= winRect.left;

	// It seems to need a few extra pixels added to the height
	// (there should be a better way to do this)
	winRect.bottom += 2;

	// Allow for the height of the toolbar
	CControlBar* pBar = GetControlBar(ID_VIEW_TOOLBAR);
	RECT barRect;
	if (pBar != NULL)
	{
		pBar->GetClientRect(&barRect);
		winRect.bottom += barRect.bottom;
	}

	// Allow for the height of the status bar
	pBar = GetControlBar(ID_VIEW_STATUS_BAR);
	if (pBar != NULL)
	{
		pBar->GetClientRect(&barRect);
		winRect.bottom += barRect.bottom;
	}

	// Set the new size the window
	SetWindowPos(NULL, NULL, NULL, winRect.right, winRect.bottom,
				 SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);

} /* CMainFrame::SetSize */


/////////////////////////////////////////////////////////////////////////////

//
// These functions keep the client area the same size when the toolbar
// and status bar are toggled on and off.
//

void CMainFrame::AdjustWindowSize(UINT nID)
{
	CFrameWnd::OnBarCheck(nID);

	// Get the height of the toolbar
	CControlBar* pBar = GetControlBar(nID);
	if (pBar != NULL)
	{
		// Get the dimensions of the toolbar
		RECT toolbarRect;
		pBar->GetClientRect(&toolbarRect);

		// Get the dimensions of the window
		RECT winRect;
		GetWindowRect(&winRect);
		winRect.right -= winRect.left;
		winRect.bottom -= winRect.top;

		// Change the size of the window to keep the active area the same
		if (pBar->GetStyle() & WS_VISIBLE)
			winRect.bottom += toolbarRect.bottom;
		else
			winRect.bottom -= toolbarRect.bottom;

		SetWindowPos(NULL, NULL, NULL, winRect.right, winRect.bottom,
					 SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}
} /* CMainFrame::AdjustWindowSize */


void CMainFrame::OnViewToolbar() 
{
	AdjustWindowSize(ID_VIEW_TOOLBAR);
}

void CMainFrame::OnViewStatusBar() 
{
	AdjustWindowSize(ID_VIEW_STATUS_BAR);
}


/////////////////////////////////////////////////////////////////////////////
