///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File:  Movie2DProxy.h
//
// Author: Matthew Leditschke, CSELT, Matthew.Leditschke@cselt.it
//
// Description:
//   The definition of the proxy object used by the presenter
//   to render the Movie2D node.
//
// Created: August, 1997.
//
// Modified:
//
///////////////////////////////////////////////////////////////////////////


#ifndef MOVIE2D_PROXY_H
#define MOVIE2D_PROXY_H


#include "DrawableImage.h"


class Movie2DProxy : public DrawableImage
{
public:
	Movie2DProxy(MediaObject* pMO);

	// Return a pointer to the Movie2D node that this node is the proxy for
	Movie2D* GetMovie2D() const { return (Movie2D*)GetObject(); }

	// Functions inherited from the base classes
	void Print(FILE* outfile, int depth) const;
	void PreRender(Effects const& effects);
	void OnEndOfStream();


	// Private implementation details
private:
	BOOL m_firstTimeAtStartTime;
	BOOL m_firstTimeAtStopTime;
	BOOL m_endOfTimeReached;
	double m_startTime;
	int m_timesStarted;
};


#endif // MOVIE2D_PROXY_H
