///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File: custom.h
//
// Author: Matthew Leditschke, CSELT, Matthew.Leditschke@cselt.it
//
// Description:
//   The definition of the macros which are used to customise the
//   definition and implementation of some of the Core classes.
//
// Created: September, 1997.
//
// Modified:
//
///////////////////////////////////////////////////////////////////////////


#ifndef CUSTOM_H
#define CUSTOM_H

#include "Presenter-CSELT.h"


#define CUSTOMIZE_EXECUTIVE_DECLARATION \
public: \
	class Root* GetSceneRoot() const { return (class Root*)m_pScene; }
#define CUSTOMIZE_EXECUTIVE_CONSTRUCTOR
#define CUSTOMIZE_EXECUTIVE_DESTRUCTOR
#define CUSTOMIZE_EXECUTIVE_START

#define CUSTOMIZE_MEDIAOBJECT_DECLARATION \
private: \
	void *m_pPresenterData; \
public: \
	virtual void RegisterObject() { m_pPresenterData = NULL; } \
	void *GetPresenterData () const { return m_pPresenterData; } \
	void SetPresenterData (void* pPresData) \
		{ m_pPresenterData = pPresData; }

#define CUSTOMIZE_MEDIAOBJECT_CONSTRUCTOR
#define CUSTOMIZE_MEDIAOBJECT_DESTRUCTOR \
	((PresenterCSELT*)GetExecutive()->GetPresenter())->DeleteObject(this);

#define CUSTOMIZE_MEDIAOBJECT_INITIALIZATION \
	RegisterObject();

#define CUSTOMIZE_STREAMCONSUMER_DECLARATION \
public: \
	void SetObjectDescriptorID (int odID) {objectDescriptorID = odID;}
#define CUSTOMIZE_STREAMCONSUMER_CONSTRUCTOR
#define CUSTOMIZE_STREAMCONSUMER_DESTRUCTOR

#define CUSTOMIZE_GROUPNODE_DECLARATION
#define CUSTOMIZE_GROUPNODE_INITIALIZATION
#define CUSTOMIZE_ROOT_DECLARATION

#define CUSTOMIZE_PRESENTER_DECLARATION
#define CUSTOMIZE_AUDIORENDERER_DECLARATION
#define CUSTOMIZE_VISUALRENDERER_DECLARATION


#endif // CUSTOM_H
