#if !defined(_file_h)	// Sentry, use file only if it's not already included.
#define _file_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  DMIF
FILE:       File.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of FileService
-------------------------------------------------------------------------*/
#include "Service.h"
#include "ztl.h"

class FileService : public Service
{
	FILE *m_fInput;
	BOOL m_bActive;
	ZMutex m_mtxChannels;
	int m_nChannelWaitedFor;
	ZSemaphore m_smpWaitForChannel;
	ZSemaphore m_smpThread;

	struct ChannelAssociation
	{   
		int m_nESid;
		BOOL m_bReady;
		ChannelAssociation (int nESid = -1) :
			m_nESid (nESid),
			m_bReady (FALSE)
		{}
		BOOL operator == (const ChannelAssociation &rElement) const
		{
			return (m_nESid >> 6) == (rElement.m_nESid >> 6);
		}
	};
	ZArray<ChannelAssociation> m_channelMap;

private:
	void FileThread ();
	int GetByte ();

public:
	FileService (ALManager *pAL);
	~FileService ();
	virtual void Connect (LPCSTR szFileName);
	virtual void Close ();
	virtual void OpenChannels (
		int nNumberOfChannels,
		const int *pESidList
	);
	virtual void ChannelsReady (
		int nNumberOfChannels,
		const int *pAssociationTagList
	);
};

#endif                                      // _file_h sentry.
