#if !defined(_g723dec_h)	// Sentry, use file only if it's not already included.
#define _g723dec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       G723GDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of G723Decoder (simulation)
-------------------------------------------------------------------------*/
#include "Decoder.h"


extern "C"
{
	CALLBACK INITdec (short nCode);
	CALLBACK DecSoundFrame (LPVOID pBlockIn, LPVOID pBlockOut);
}
#define DECODE_ERROR   SHRT_MAX
#define G723_53 0
#define G723_63 1

class G723Decoder : public Decoder
{
	int m_nSamples;

	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () {return 24;}
	virtual int GetOptimalOutputSize () {return 480;}
	virtual int GetRecommendedInputBufferSize () {return 256;}
	virtual int GetRecommendedOutputBufferSize () {return 960;}
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	virtual void Run ();

public:
	G723Decoder (class Executive *pExecutive) : Decoder (pExecutive) {}
};

#endif                                      // _g723dec_h sentry.
