#if !defined(_Im1defs_h)	// Sentry, use file only if it's not already included.
#define _Im1defs_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  all
FILE:       Im1defs.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Constants and typedefs for Implementation 1
-------------------------------------------------------------------------*/
typedef enum tagFormat
{	FORMAT_UNKNOWN,
	FORMAT_RGB,
	FORMAT_BGR,
	FORMAT_RGBA,
	FORMAT_YUV,
	FORMAT_YUVA,
	FORMAT_TEXT,
	FORMAT_PCM
} FORMAT;

typedef enum tagDecoderType
{	DT_UNKNOWN,
	DT_H263,
	DT_G723,
	DT_JPEG,
	DT_TEXT,
	DT_FBA,
	DT_AAC_L1
} DECODER_TYPE;

typedef enum tagDefaultMPEG4Values
{
	MPEG4_DEFAULT_BIFS_BUFFER_SIZE = 10000,
	MPEG4_TOTAL_NUMBER_OF_NODES = 100
};

typedef struct tagES_Descriptor ES_DESCRIPTOR;
typedef struct tagESConfigParams ESCONFIGPARAMS;

#define END_OF_STREAM  ((void*)-1)

typedef enum tagConnectionResult
{	
	CONNECTION_SUCCESS, FILE_NOT_FOUND, CANNOT_OPEN_FILE,
	IP_ADDRESS_NOT_FOUND, CANNOT_OPEN_SOCKET, MEMORY_PROBLEM,
	UNEXPECTED_EOF
}
CONNECTION_RESULT;

typedef enum tagServiceTermination
{	
	END_OF_SERVICE, HARDWARE_ERROR, COMMUNICATION_DISCONNECTED,
	REMOTE_TIME_OUT
}
SERVICE_TERMINATION;

typedef enum tagServiceType
{	
	FILE_SERVICE, REMOTE_SERVICE
}
SERVICE_TYPE;

typedef enum tagUserEvent
{
	EVENT_MOUSE_DOWN, EVENT_MOUSE_UP, EVENT_MOUSE_MOVE
} USER_EVENT;

typedef enum tagControlKey
{
	CK_CONTROL, CK_SHIFT, CK_ALT
} CONTROL_KEY;

typedef struct
{
	unsigned short width;
	unsigned short height;
	unsigned short pitch;
	signed short offsetX;
	signed short offsetY;
} DecoderImage;

typedef struct
{
    DWORD samplesPerSecond;
    UCHAR bitsPerSample;
    UCHAR numChannels;
} DecoderAudioFormat;

#endif                                      // _Im1defs_h sentry.
