/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       RGBDec.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Implementation of RGBDecoder
-------------------------------------------------------------------------*/
#include "Defs.h"
#include "RGBDec.h"

/*-----------------------------------------------------------------
Find a compatible format and initialize the decoder
-----------------------------------------------------------------*/
FORMAT RGBDecoder :: SetFormat (Capabilities *)
{
	return FORMAT_RGB;
}

BOOL RGBDecoder :: Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
)
{
	if (rnOutputLength < GetOptimalOutputSize ())
	{	rnOutputLength = GetOptimalOutputSize ();
		return FALSE;
	}

	STOREWORD (176, pOutput);
	STOREWORD (144, pOutput + sizeof (WORD));
	memcpy (pOutput + 2 * sizeof (WORD), pInput + 3, nInputLength - 3);
	rnOutputLength = GetOptimalOutputSize ();
	return TRUE;
}