// -*- c++ -*-

#if !defined(_Route_h)	// Sentry, use file only if it's not already included.
#define _Route_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor
FILE:       Route.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declarations of Route
-------------------------------------------------------------------------*/

class MediaObject;
class NodeField;

class Route
{
	int m_nRouteID;
	NodeField *m_pDepartureField;
	MediaObject *m_pArrivalNode;
	int m_nArrivalField;
	Route *m_pNext, *m_pNextArrival;

public:
	Route (int routeID, NodeField *pDepartureField);
	~Route ();
	void Bind (MediaObject *pArrivalNode, int nArrivalField);
	void Activate ();
	void Link (Route *&rpListHead);
	void Unlink (Route *&rpListHead);
	void LinkArrival (Route *&rpListHead);
	void UnlinkArrival (Route *&rpListHead);
	Route *GetNext () {return m_pNext;}
	int GetID () const {return m_nRouteID;}
};

#endif                                      // _Route_h sentry.
