/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor / Presenters
FILE:       StrAssoc.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Implementation of a SessionStreamAssociation class.
-------------------------------------------------------------------------*/
#include "defs.h"
#include "StrAssoc.h"
#include "NodeCode.h"
#include "Im1Defs.h"
#include "ESConfig.h"
#include "Executiv.h"

BIFS_IMPLEMENT_NODE_START(SessionStreamAssociation)
	 BIFS_CHILDREN(SessionStreamAssociation, children, 0, 0, -1, -1)
BIFS_IMPLEMENT_NODE_END(SessionStreamAssociation)

BIFS_IMPLEMENT_NODE_START(ObjectDescriptor)
	 BIFS_FIELD(ObjectDescriptor, objectDescriptorID, 0, 0, -1, -1, 0, 0)
	 BIFS_FIELD(ObjectDescriptor, decTypeString, 1, 1, -1, -1, 0, 0)
	 BIFS_FIELD1(ObjectDescriptor, configParam, 2, 2, -1, -1, 0, 0, 0, 127)
	 BIFS_FIELD(ObjectDescriptor, fileName, 3, 3, -1, -1, 0, 0)
BIFS_IMPLEMENT_NODE_END(ObjectDescriptor)

#ifndef BIFSENC
/*-----------------------------------------------------------------
Set streams for all the children
-----------------------------------------------------------------*/
void SessionStreamAssociation :: SetStreams ()
{
	for (int i = 0; i < children.GetLength (); i++)
		children [i] -> SetStream ();
}

/*-----------------------------------------------------------------
Set a stream for an object descriptor
-----------------------------------------------------------------*/
void ObjectDescriptor :: SetStream ()
{
	ES_DESCRIPTOR objectDesc;

	objectDesc.m_nVersion = 10;
	objectDesc.m_nES_number = 1;
	assert (decTypeString.GetLength () < sizeof objectDesc.m_szDecType);
	strcpy (objectDesc.m_szDecType, decTypeString);
	objectDesc.m_ESConfigParams.m_nVersion = 10;
	objectDesc.m_ESConfigParams.m_nPredefined = configParam;

	GetExecutive () ->
		SetStream (objectDescriptorID, &objectDesc, fileName);
}

#endif	// BIFSENC