#if !defined(_StreamCo_h)	// Sentry, use file only if it's not already included.
#define _StreamCo_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor / Presenter
FILE:       MediaObj.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declarations of StreamConsumer
-------------------------------------------------------------------------*/
#include "MediaObj.h"
#include "NodeFld.h"
#include "ESConfig.h"

class MediaStream;
class Decoder;
class DataChannel;
class Service;
class ALManager;

class StreamConsumer : public MediaObject
{
protected:
	SFObjectID objectDescriptorID;

#ifndef BIFSENC
private:
	MediaStream *m_pStream;
	FORMAT m_fmtStreamFormat;
	Decoder *m_pDecoder;
	DataChannel *m_pChannel;
	ALManager *m_pAL;
	Service *m_pService;
	ESCONFIGPARAMS m_configParams;
	int m_nESNumber;

	virtual BOOL Parse (BIFSDecoder *pBifs);

public:
	ES_DESCRIPTOR* m_copyOfESdesc;
	char* m_copyOfFileName;

public:
	StreamConsumer ();
	virtual ~StreamConsumer ();
	void SetStream (ES_DESCRIPTOR *pES_Descriptor, LPCSTR szFileName);
	MediaStream *GetStream () {return m_pStream;}
	void AttachStream (ALManager *pAL);
	FORMAT GetStreamFormat () {return m_fmtStreamFormat;}
	int GetObjectDescriptorID () {return objectDescriptorID;}
	void OpenStream ();
	void CloseStream ();
	Service *GetService () {return m_pService;}
	void OnConnect (CONNECTION_RESULT result = CONNECTION_SUCCESS);

	CUSTOMIZE_STREAMCONSUMER_DECLARATION
#endif	// BIFSENC
};

#endif                                      // _StreamCo_h sentry.
