/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder
FILE:       bifs.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Implementation of classes for pre-preparing of bifs tables.
-------------------------------------------------------------------------*/

#include "defs.h"
#include "bifs.h"

/*-----------------------------------------------------------------
BifsBounds constructor constructs the value of its fields out of a 
BIFS table
-----------------------------------------------------------------*/
BifsBounds :: BifsBounds (const BifsFieldTable *pTable, int nSize)
{
	for (int i = nSize; --i >= 0;)
	{	if (pTable [i].m_defID >= 0)
			++m_nTotalDefs;
		if (pTable [i].m_inID >= 0)
			++m_nTotalIns;
		if (pTable [i].m_outID >= 0)
			++m_nTotalOuts;
		if (pTable [i].m_dynID >= 0)
			++m_nTotalDyns;
	}
	m_nBitsPerDef = BitFieldWidth (m_nTotalDefs);
	m_nBitsPerIn = BitFieldWidth (m_nTotalIns);
	m_nBitsPerOut = BitFieldWidth (m_nTotalOuts);
	m_nBitsPerDyn = BitFieldWidth (m_nTotalDyns);
};
