#if !defined(_defs_h)	// Sentry, use file only if it's not already included.
#define _defs_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  all
FILE:       defs.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Platform independent type definitions
-------------------------------------------------------------------------*/
#ifdef WIN32

#pragma warning(disable: 4201)  // nonstandard extension used : nameless struct/union
#pragma warning(disable: 4514)  // unreferenced inline function has been removed
#pragma warning(disable: 4226)  // nonstandard extension used : 'pascal' is an obsolete keyword
#pragma warning(disable: 4244)  // conversion from 'const int' to 'float', possible loss of data
#pragma warning(disable: 4355)  // 'this' : used in base member initializer list

#define STOREINT(n, pBuf) (* (int *) (pBuf) = n)
#define LOADINT(pBuf) (* (int *) (pBuf))
#define STOREWORD(n, pBuf) (* (WORD *) (pBuf) = n)
#define LOADWORD(pBuf) (* (WORD *) (pBuf))
#define STOREDWORD(n, pBuf) (* (DWORD *) (pBuf) = n)
#define LOADDWORD(pBuf) (* (DWORD *) (pBuf))

#ifdef BUILD_CSELT_APP

#include <afxwin.h>             // MFC core and standard components
#include <afxext.h>             // MFC extensions
#include "mmsystem.h"

#ifndef _AFX_NO_AFXCMN_SUPPORT

#include <afxcmn.h>             // MFC support for Windows Common Controls

#endif	// _AFX_NO_AFXCMN_SUPPORT

#else	// BUILD_CSELT_APP 

#include <windows.h>       /* Windows include file */
#include <stdio.h>

#endif	// BUILD_CSELT_APP

#define COMPLAIN(a) OutputDebugString(a)
#define M_PI 3.1415926535
#define ALMOST_ZERO 1e-10

#ifndef TRACE

inline void TRACE (const char* a, ...)
{
	va_list marker;
	char buf[1024];

	va_start(marker, a);
	vsprintf(buf, a, marker);
	OutputDebugString(buf);
	va_end(marker);
}

#endif	// TRACE

#else	// WIN32

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

typedef char *LPSTR;
typedef const char* LPCSTR;
typedef short WORD;
typedef char BYTE;
typedef struct tagRect {int left, top, width, height;} RECT;

#ifndef BOOL
typedef int BOOL;
#endif	// BOOL

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif	// TRUE

#define min(a,b) ((a)>(b)?(b):(a))
#define max(a,b) ((a)<(b)?(b):(a))

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))

#define STOREWORD(n, pBuf) \
	((pBuf) [0] = LOBYTE (n), (pBuf) [1] = HIBYTE (n))

#define STOREDWORD(n, pBuf) \
	(	STOREWORD (LOWORD (n, (pBuf)), \
		STOREWORD (HIWORD (n, (pBuf) + sizeof (WORD) \
	)

#define STOREINT(n, pBuf) STOREDWORD (n, pBuf)

#define LOADWORD(pBuf) MAKEWORD ((pBuf) [0], (pBuf) [1])

#define LOADDWORD(pBuf) \
	MAKELONG (LOADWORD (pBuf), LOADWORD ((pBuf) + sizeof (WORD))

#define LOADINT(pBuf) LOADDWORD (pBuf)

#define COMPLAIN(a) printf(a)

#endif	// ndef WIN32

#endif                                      // _defs_h sentry.
