#if !defined(_Factory_h)  // Sentry, use file only if it's not already included.
#define _Factory_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       Factory.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declaration of StreamFactory, the template class that creates
Stream objects.
-------------------------------------------------------------------------*/
class Stream;

/*-----------------------------------------------------------------
Declare a base class for the template
-----------------------------------------------------------------*/
class StreamFactoryBase
{
	LPCSTR m_szType;

public:
	StreamFactoryBase (LPCSTR szType);
	BOOL IsTypeOf (LPCSTR szType) {return !stricmp (szType, m_szType);}
	virtual Stream *Create (FILE *fStream, const char* streamData = NULL) = 0;
};

/*-----------------------------------------------------------------
Declare the template
-----------------------------------------------------------------*/
template <class T> class StreamFactory : public StreamFactoryBase
{
public:
	StreamFactory (LPCSTR szType) : StreamFactoryBase (szType) {}
	virtual Stream *Create (FILE *fStream, const char* streamData)
	{return new T (fStream, streamData);}
};

#endif	// _Factory_h sentry