#if !defined(_H263_h)  // Sentry, use file only if it's not already included.
#define _H263_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       H263.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declaration of H263, the class that handles H.263 streams
-------------------------------------------------------------------------*/
#include "Stream.h"

class H263Stream : public Stream
{
	int m_cNext [3];
	long m_lFrames;
	BOOL m_bStart;
	float m_frameRate;

public:
	H263Stream (FILE *fStream, const char* streamData);
	virtual long GetTimeStamp ();
	virtual int GetChar ();
};

#endif	// _H263_h sentry