/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       MuxEncValue.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Parsing of a simple-value NodeField objects
-------------------------------------------------------------------------*/
#include "defs.h"
#include "NodeFld.h"
#include "Token.h"
#include "BifsEnc.h"

/*-----------------------------------------------------------------
Encode an SFInt
-----------------------------------------------------------------*/
BOOL SF<int> :: Encode (BIFSEncoder *,  Quantizer *)
{
	/*-----------------------------------------------------------------
	Look at the Quantizer to see if min-max values applied
	-----------------------------------------------------------------*/
	m_value = nextToken.GetInt ();
	return TRUE;
}

/*-----------------------------------------------------------------
Encode an SFBool
-----------------------------------------------------------------*/
BOOL SF<Bool> :: Encode (BIFSEncoder *, Quantizer *)
{
	m_value = nextToken.GetBool ();
	return TRUE;
}

/*-----------------------------------------------------------------
Encode and SFFloat
-----------------------------------------------------------------*/
BOOL SF<float> :: Encode (BIFSEncoder *,  Quantizer *)
{
	m_value = nextToken.GetReal ();
	return TRUE;
}

/*-----------------------------------------------------------------
Encode an SFTime
-----------------------------------------------------------------*/
BOOL SF<Time> :: Encode (BIFSEncoder *,  Quantizer *)
{
	m_value = nextToken.GetReal ();
	return TRUE;
}

/*-----------------------------------------------------------------
Encode an SFObjectID
-----------------------------------------------------------------*/
BOOL SFObjectID :: Encode (BIFSEncoder *, Quantizer *)
{
	m_value = nextToken.GetInt ();
	return TRUE;
}

/*-----------------------------------------------------------------
Encode SFString
-----------------------------------------------------------------*/
BOOL SF<ZString> :: Encode (BIFSEncoder *, Quantizer *)
{
	m_value = nextToken.GetString ();
	nextToken.Scan ();
	return TRUE;
}

/*-----------------------------------------------------------------
A dummy implementation of BIFSEncoder :: EncodeInt ()
-----------------------------------------------------------------*/
void BIFSEncoder :: EncodeInt (int, int, LPCSTR) {}

/*-----------------------------------------------------------------
A dummy implementation of NodeField :: EncodeElement ()
-----------------------------------------------------------------*/
BOOL NodeField :: EncodeElement (BIFSEncoder *, Quantizer *)
{
	return FALSE;
}
