#if !defined(_Stream_h)  // Sentry, use file only if it's not already included.
#define _Stream_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       Stream.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declaration of Stream, the base class for objects that handles
input streams.
-------------------------------------------------------------------------*/
#include "Factory.h"

class Stream
{
	FILE *m_fStream;

public:
	Stream (FILE *fStream) : m_fStream (fStream) {}
	virtual ~Stream () {}
	virtual long GetTimeStamp () = 0;
	virtual int GetChar () = 0;
	virtual int GetPaddingBits () {return 0;}

protected:
	int getc () {return fgetc (m_fStream);}
};

#endif	// _Stream_h sentry