/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       main.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   main() function for the off-line Mux
-------------------------------------------------------------------------*/
#include "defs.h"
#define MAIN
#include "Token.h"
#include "Mux.h"

Token nextToken;

int main (int argc, char **argv)
{
	FILE *fInput, *fMP4, *fList;
	int nNameLength;

	if (argc < 2)
	{	printf ("Missing file name\n");
		return -1;
	}

	/*-----------------------------------------------------------------
	Source file name extension is "scr", output extension is "mp4" and
	list file is "lst"
	-----------------------------------------------------------------*/
	ZString stFileName (*++argv);
	nNameLength = stFileName.GetLength ();
	LPCSTR szExt = strrchr (stFileName, '.');
	if (szExt && !strchr (szExt, '\\'))
		nNameLength -= strlen (szExt);
	else
		stFileName += ".scr";

	if ((fInput = fopen (stFileName, "r")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}
	stFileName.Cut (nNameLength);
	stFileName += ".mp4";
	if ((fMP4 = fopen (stFileName, "wb")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}
	stFileName.Cut (nNameLength);
	stFileName += ".lst";
	if ((fList = fopen (stFileName, "w")) == NULL)
	{	printf ("Cannot open %s\n", (LPCSTR) stFileName);
		return -1;
	}

	/*-----------------------------------------------------------------
	The Multiplex work is done by the Mux object
	-----------------------------------------------------------------*/
	nextToken.Init (fInput, fList);
	Mux (fMP4).Start ();
	return 0;
}